----------------------------------------------------------------------------------
-- ECE 3401 Spring 2024: Programming Assignment 3 Test Bench #1
-- University of Connecticut 
----------------------------------------------------------------------------------

-----------------------------
-- DO NOT MODIFY THIS FILE --
-----------------------------

library IEEE;
library work;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity prefix_tb1 is
end prefix_tb1;

architecture Behavioral of prefix_tb1 is
    component pa3 is
    port(
         --Inputs
         n   : in unsigned(4 downto 0);
         clk : in std_logic;
         
         --Outputs
         n_fact : out unsigned(63 downto 0);
         ready  : out std_logic
    );
    end component;
    
    -- Clock period definitions
    constant clk_period : time := 10 ns;
    signal cur_cycle : integer := 0;
    
    -- Input / output signals 
    signal n      : unsigned(4 downto 0);
    signal n_fact : unsigned(63 downto 0);
    signal clk, ready : std_logic;
       
begin
    uut: pa3 port map(
         n => n,
         clk => clk,
         n_fact => n_fact,
         ready => ready);
        
         clk_process: process
         begin
            clk <= '1';
            wait for clk_period/2;
            clk <= '0';
            wait for clk_period/2;
            cur_cycle <= cur_cycle + 1;
         end process;
       
     --Stimulus process
     stim_proc: process
        variable fact_exp : unsigned(63 downto 0);
     begin 
        
        ---------------
        -- Testing 3 --
        ---------------
        -- Set n and wait
        n <= to_unsigned(3, 5);
        wait until rising_edge(ready);
        
        -- Verify output value
        fact_exp := to_unsigned(1 ,64);
        for i in to_integer(n) downto 1 loop
            fact_exp := resize(fact_exp * to_unsigned(i, 64), 64);
        end loop;
        assert (n_fact = fact_exp) report "The output of " & integer'image(to_integer(n)) & "! is not correct." severity WARNING;
        

        ----------------
        -- Testing 20 --
        ----------------
        n <= to_unsigned(20, 5);
        wait until rising_edge(ready);
        
        -- Verify output value
        fact_exp := to_unsigned(1 ,64);
        for i in to_integer(n) downto 1 loop
            fact_exp := resize(fact_exp * to_unsigned(i, 64), 64);
        end loop;
        assert (n_fact = fact_exp) report "The output of " & integer'image(to_integer(n)) & "! is not correct." severity WARNING;
        

        ---------------
        -- Testing 0 --
        ---------------
        n <= to_unsigned(0, 5);
        wait until rising_edge(ready);
        
        -- Verify output value
        fact_exp := to_unsigned(1 ,64);
        for i in to_integer(n) downto 1 loop
            fact_exp := resize(fact_exp * to_unsigned(i, 64), 64);
        end loop;
        assert (n_fact = fact_exp) report "The output of " & integer'image(to_integer(n)) & "! is not correct." severity WARNING;
        
        
        ---------------
        -- Testing 5 --
        ---------------
        n <= to_unsigned(5, 5);
        wait until rising_edge(ready);
        
        -- Verify output value
        fact_exp := to_unsigned(1 ,64);
        for i in to_integer(n) downto 1 loop
            fact_exp := resize(fact_exp * to_unsigned(i, 64), 64);
        end loop;
        assert (n_fact = fact_exp) report "The output of " & integer'image(to_integer(n)) & "! is not correct." severity WARNING;
     end process;
end Behavioral;
